diff --git a/pc-bios/bios-microvm.bin b/pc-bios/bios-microvm.bin
new file mode 100644
index 0000000000000000000000000000000000000000..eefd32197e8d637be0266e3410551f711728c6d0
GIT binary patch
diff --git a/pc-bios/meson.build b/pc-bios/meson.build
index 9759dba09714..a0d21be4321a 100644
--- a/pc-bios/meson.build
+++ b/pc-bios/meson.build
@@ -27,6 +27,7 @@ endif
 blobs = files(
   'bios.bin',
   'bios-256k.bin',
+  'bios-microvm.bin',
   'qboot.rom',
   'sgabios.bin',
   'vgabios.bin',